

import java.io.BufferedReader;
import java.io.BufferedWriter;
import java.io.File;
import java.io.FileReader;
import java.io.FileWriter;
import java.io.IOException;
import java.io.InputStreamReader;
import java.util.ArrayList;
import java.util.HashMap;
import java.util.HashSet;
import java.util.Hashtable;
import java.util.List;
import java.util.Map;
import java.util.Random;
import java.util.Set;
import org.apache.commons.math.util.MathUtils;


import com.sun.org.apache.bcel.internal.generic.GETSTATIC;

public class ANNETADist{
	
	Hashtable<String, Integer> indices = new Hashtable<String, Integer>();
	
	private List<Protein> baits;
	private static String PATH;
	double Dist[][];
	double probMatrix[][];
	
	double triangles[][][];
	double doublets[][];
	double YTriangles[][];

	List<Double> mean;
    List<Double> variance;
    List<Double> stats;

    int numProt = 0;
    double largestEntryInMatrix = 0;

	double roundedDist[][];
   
	double roundFactor = 1.0;

    double stopProb = 0.0;
   
	List<TreeNode> significantGroups = null;
	double significantpValue = 0.05;
	
   	double MAX = 0.0;
   
   	public void findGroup(String path, String networkFileName, String distMatrixFileName, String probabilitySimuFileName, int pSamplingNumber, String annotationFileName, int maximumGroupSize) throws Exception {
		InputStreamReader input = new InputStreamReader(System.in);
	    BufferedReader reader = new BufferedReader(input);
        File relationsFile = null;
//        System.out.println("Want to use HuPi or Krogan or Silico or Collins set?");
//        String s = reader.readLine();
        String networkFile = networkFileName;
        String distMatrixFile = distMatrixFileName;
        String probabilitySimuFile = probabilitySimuFileName;
        int samplingNumber = pSamplingNumber;
        String annotationFile = annotationFileName;
        int maxGroupSize= maximumGroupSize;
        PATH = path;
//        int simMatrixChoice = -1;
//    	stopProb = 0.15;
        
//    	if (s.equals("hupi")){
        	//Jeronimo DataSet
        	relationsFile = new File(PATH + networkFile);
        	//XAB1 Paper DataSet
        	//relationsFile = new File("src/go/XAB1PaperRelsRatio2.txt");
        	//HPRD Database
        	//relationsFile = new File("src/go/HPRDRelations.txt");
//        	simMatrixChoice = 0;
//        }
//        else if(s.equals("krogan")){
//       	relationsFile = new File("src/go/KroganTable7SubsetProteinList.txt");
//        	simMatrixChoice = 1;
//       	try{
//    			File MFile = new File("src/go/KroganTable7SubsetDistanceMatrix.txt");
//   			FileReader fRM = new FileReader(MFile);
//    			BufferedReader MReader = new BufferedReader(fRM);
//    			String MLine = MReader.readLine();
//    			numProt = MLine.split("t").length;
//    			MReader.close();
//    		}catch (Exception e) {
//    			e.printStackTrace();
//    		}
//        }
//        else if(s.equalsIgnoreCase("Collins")){
//        	relationsFile = new File("src/go/CollinsConnectedHighConfDataSet.txt");
//        	simMatrixChoice = 2;
//        }
    	
//        else{
//        	System.out.println("Wrong choice of file");
//        	return;
//        }
        
	    FileReader fRRelation = new FileReader(relationsFile);
		BufferedReader relationsReader = new BufferedReader(fRRelation);
		//Output file for the GOCloseGroup were found
		
		List<Pair<Protein,List<Protein>>> proteinList = null;
//		if (s.equalsIgnoreCase("Collins")){
			//Read relation file
//			List<Relation> relations = createRelationListCollins(relationsReader);
			//Check for baits in relations
//			baits = createBaitList(relations);
			//Create data structures for relations
//			proteinList = createAdjacencyList(relations,baits);
//		}
//		else if (s.equals("hupi")){
			//Read relation file
			List<Relation> relations = createRelationList(relationsReader);
			//Check for baits in relations
			baits = createBaitList(relations);
			//Create data structures for relations
			proteinList = createAdjacencyList(relations,baits);
//		}
//		else{
//			proteinList = readAdjacencyList(relationsReader);
//		}
		
		for(int i = 0; i < proteinList.size(); i++){
			indices.put(proteinList.get(i).getf().getName(),i);
		}
			
			
		//Read the distance matrix from the file.
//		if (!DataSet.equals("krogan")){
			getMatrix(proteinList,distMatrixFile);
//		}
//		else{
//			getKroganMatrix(proteinList);
//		}
		System.out.println("Distance matrix read.");
        System.out.println(Dist.length + " proteins ");
        System.out.println("Largest distance in Matrix = " + largestEntryInMatrix);
        
//        if (!DataSet.equals("krogan")){
        	stats = getStats(proteinList);
//		}
//		else{
//			stats = getKroganStats(proteinList);
//		}
		int listSize = proteinList.size(); 



//		System.out.println("Do you want to estimate the pValue witht the triangle method(y/n) ?");
//		String s = reader.readLine();
//		if(s.equals("y")){
//		   	System.out.println("enumarating all triangles probability");
//		   	enumerateAllTrianglesProb(); 
//		  	System.out.println("Do you want to round the mean for the triangle matrix(y/n) ?");
//		   	newComputeTriangleBasedEstimatorProbs(listSize,stats,true,false);
//		   	s = reader.readLine();
//		   	if(s.equals("y")){
		   		//newComputeTriangleBasedEstimatorProbs(listSize,stats,true,false,largestPath,DataSet);
		   		//computeTriangleBasedEstimatorProbs(listSize,stats,true,false);
				//computeTriangleBasedEstimatorProbsAllIndependant(listSize,stats,true,false);
//		   	}
//		   	else{
//		   		System.out.println("Weighted sum(y/n)?");
//		   		s = reader.readLine();
//		   		if (s.equals("y")){
		   			//newComputeTriangleBasedEstimatorProbs(listSize,stats,false,true,largestPath,DataSet);;
//		   		}
//		   		else{
		   			//newComputeTriangleBasedEstimatorProbs(listSize,stats,false,false,largestPath,DataSet);
//		   		}
//		   	}
//		 }
		

//		 System.out.println("Do you want to compute a new upper bound matrix probabilities\nbased on a normal distribution(y/n) ?");
//		 s = reader.readLine();
		        
//		 boolean compNormalProbOnTheFly = false;
		       
//		 mean = null;
//		 variance = null;
		        
//		 if (s.equals("y")){
//			 System.out.println("Computing Means.");
//		     mean = computeMean(listSize);
//		     System.out.println("Computing Variances.");
//		     variance = computeVariance(listSize,mean);
//		     computeProbMatrix(listSize,mean,variance,stats,DataSet);
//		 }
		        
 //       System.out.println("Do you want to compute a new lower bound matrix probabilities\nbased on the row method(y/n) ?");
 //       s = reader.readLine();
 //       if (s.equals("y")){
 //   	    System.out.println("Computing Individual Matrix...");
 //      	computeProbMatrices(listSize,stats,DataSet);
 //       	System.out.println("Computing Final Probability Matrix...");
 //   	    computeFinalRowProbMatrix(listSize,stats,DataSet);
 //       }

 //       System.out.println("Do you want to compute a new simulation for the data set(y/n) ?");
 //       s = reader.readLine();
		
        if(probabilitySimuFile.equals("null")){
        	//System.out.println("How many repetitions do you want to do:");
        	//int rep = 10000000;
        	System.out.println("Simulating probabilities...");
        	simulateRealLife(listSize,stats,samplingNumber,networkFile,distMatrixFile);
        	probabilitySimuFile = networkFileName +"_"+ distMatrixFile + "SimuProb" + samplingNumber;
        }
	    
        
        System.out.println("Loading Gene Sets...");
        BufferedReader inGeneSets = new BufferedReader(new FileReader(new File(PATH + annotationFile)));
        Set<ANGeneSet> ANGeneSets = loadGeneSets(proteinList,inGeneSets);
        System.out.println("Gene Sets loaded");
        System.out.println(ANGeneSets.size());
        
    	significantGroups = new ArrayList<TreeNode>();
        Set<List<ANGeneSet>> goodGeneSets = findSignificantGeneSets(proteinList, ANGeneSets, probabilitySimuFile, maxGroupSize);
	    BufferedWriter out = new BufferedWriter(new FileWriter(PATH + networkFile + "Results"));
	    //BufferedWriter out = new BufferedWriter(new FileWriter("src/go/HuPIOriginalGoGroupsGreedyImprovedWeightedDistanceWMax100.txt"));
        for(List<ANGeneSet> gsList: goodGeneSets){
        	for(ANGeneSet gs: gsList){
	        	out.write("Gene Set : " + gs.getGeneSetName() + ", Average Distance: " + gs.getAvgD() + "\n");
	        	out.write("Normal approximation p-Value : " + gs.getUpperPValue() + "\n");
	        	out.write("Y-convolution p-Value : " + gs.getLowerPValue() + "\n");
	        	out.write("Triangle decomposition (rounding) p-Value : " + gs.getTRPValue() + "\n");
	        	out.write("Triangle decomposition (Interpol) p-Value : " + gs.getTInterpolPValue() + "\n");
	        	out.write("Monte-Carlo Estimation p-Value : " + gs.getSimuPValue() + "\n");
	        	out.write(gs.getProteins().size() + " Proteins with this GO Function\n" );
	        	for(Pair<Protein, List<Protein>> p: gs.getProteins()){
	        		out.write(p.getf().getName()+ "\n");
	        	}
	        	out.write(".................................\n");
	        	out.flush();
        	}
        	out.write("============================================================\n" +
        			"=========================================================\n");
        	out.flush();
        }
        out.close();
	       	
	}
	
	private double probabilityApproximation(double djk, double dik, int betaMinusa, int n){
		double prob = 0.0;
		try{
			// djk = X
			// dik = Y
			if (djk > 19 || dik >  19 || betaMinusa >= 20){
				return 0.0;
			}
			int fdjk = (int)Math.floor(djk);
			int cdjk = (int)Math.ceil(djk);
			int fdik = (int)Math.floor(dik);
			int cdik = (int)Math.ceil(dik);
			
			int comb = (int)MathUtils.binomialCoefficientDouble(n-1,2);
			double fdjkfdikProb = triangles[fdjk][fdik][betaMinusa];
			double fdjkcdikProb = triangles[fdjk][cdik][betaMinusa];
			double cdjkfdikProb = triangles[cdjk][fdik][betaMinusa];
			double cdjkcdikProb = triangles[cdjk][cdik][betaMinusa];
			
			double expfdjkfdikProb = ((1 - (djk - fdjk))) * (1 - (dik - fdik))*(n-2); 
			double expfdjkcdikProb = ((1 - (djk - fdjk))) * (dik - fdik)*(n-2);
			double expcdjkfdikProb = ((djk - fdjk)) * (1-(dik - fdik))*(n-2);
			double expcdjkcdikProb = ((djk - fdjk)) * (dik - fdik)*(n-2);
			
			double probff = 0.0;
			double probfc = 0.0;
			double probcf = 0.0;
			double probcc = 0.0;
			if (fdjkfdikProb == 0 && expfdjkfdikProb == 0){
				probff = 0.0;
			}
			else{
				probff = Math.pow(fdjkfdikProb,expfdjkfdikProb);
			}
			if (fdjkcdikProb == 0 && expfdjkcdikProb == 0){
				probfc = 0.0;
			}
			else{
				probfc = Math.pow(fdjkcdikProb,expfdjkcdikProb);
			}
			if (cdjkfdikProb == 0 && expcdjkfdikProb == 0){
				probcf = 0.0;
			}
			else{
				probcf = Math.pow(cdjkfdikProb,expcdjkfdikProb);
			}
			if (cdjkcdikProb == 0 && expcdjkcdikProb == 0){
				probcc = 0.0;
			}
			else{
				probcc = Math.pow(cdjkcdikProb,expcdjkcdikProb);
			}
			prob = probff * probfc * probcf * probcc;
			
			if(Math.pow(stats.get(betaMinusa),(n-2)-1) == 0.0){
				prob = 0.0;
			}
			else{
				prob = prob/Math.pow(stats.get(betaMinusa),(n-2)-1);
			}
		}catch (Exception e) {
			e.printStackTrace();
		}
		return prob;	



	}
	
	
	private boolean alreadyIn(int ind1, List<Integer> l){
		for(Integer i: l){
			if (ind1 == i){
				return true;
			}
		}
		return false;
	}
	
	private void simulateRealLife(int ps,List<Double> pathStats, int reps, String networkFileName,String distMatrixFile){
		try{
			Random rn = new Random();
			BufferedWriter out = new BufferedWriter(new FileWriter(PATH + networkFileName +"_"+ distMatrixFile + "SimuProb350to400" + reps));
			
			
			//if(DataSet.equals("hupi")){
				//out = new BufferedWriter(new FileWriter("src/go/HuPIOriginalSimReal2toXXprotsWeightedSimP"+ stopProb + "RF"+roundFactor+"WMax500.txt"));
			//	out = new BufferedWriter(new FileWriter("src/go/HuPIHighConfidenceFDR0.1_14Nov2010WithCompleteBiogridConnectedMay1stDistanceSim2to100PowerMinus7Proteins.txt"));
			//}
			//else if(DataSet.equalsIgnoreCase("Collins")){
			//	out = new BufferedWriter(new FileWriter("src/go/CollinsConnectedSim2to300ProteinsP"+stopProb+"RF"+roundFactor+".txt"));
			//}
			//else if(DataSet.equals("krogan")){
				//out = new BufferedWriter(new FileWriter("src/go/KroganSimSimP"+ stopProb + "prots"+ i +"RF"+roundFactor+".txt"));
			//}
			//else if(DataSet.equals("Silico")){
				//out = new BufferedWriter(new FileWriter("src/go/SilicoSimSimP"+ stopProb + "prots"+ i +"RF"+roundFactor+".txt"));
			//}

			for(int i = 350; i < 400; i++){
				System.out.println("Subset Size =" + i);
				Map<Double,Double> numberWithDistance = new HashMap<Double, Double>();
				double biggestDist = 0.0; 
				for(int rep = 0; rep < reps; rep++){
				//	Key = totaldistance and object = number of times it appeared.
					List<Integer> listProteinIndex = new ArrayList<Integer>();
					for(int j = 0; j < i; j++){
						
						double r1 = rn.nextDouble();
						int ind1 = (int)Math.floor(r1*(ps));
						if(alreadyIn((ind1),listProteinIndex)){
							j--;
						}
						else{
							listProteinIndex.add(ind1);
						}
						
					}
					double totalDistance = 0.0;
					
					for(int j = 0; j < listProteinIndex.size(); j++){
						for(int k = j+1; k < listProteinIndex.size(); k++){
							totalDistance = totalDistance + Dist[listProteinIndex.get(j)][listProteinIndex.get(k)];
						}
					}
					
					/*for(Integer p: listProteinIndex){
						for(Integer p2: listProteinIndex){
							if (p == p2){
								continue;
							}
							totalDistance = totalDistance + Dist[p][p2];
						}
					}
					totalDistance = totalDistance /2 ;
					
					totalDistance = totalDistance * roundFactor;*/
					
						
						
					totalDistance = (double)Math.round(totalDistance);
					if (totalDistance > biggestDist){
						biggestDist = totalDistance;
					}
					if (numberWithDistance.get(totalDistance) != null){
						numberWithDistance.put(totalDistance, numberWithDistance.get(totalDistance)+1);
					}
					
					else{
						numberWithDistance.put(totalDistance,1.0);
					}
				}
		
				for(double j = 0; j <= (int)(biggestDist); j++){
					if (numberWithDistance.get(j) == null){
						try{
							out.write("0.0,");
						}catch(Exception e){
							e.printStackTrace();
						}
					}
					else{
						try{
							double prob = numberWithDistance.get(j)/reps;	
							out.write(prob+",");
						}catch(Exception e){
							e.printStackTrace();
						}
					}
					
					out.flush();
				}
				out.write("\n");		
				out.flush();
				
			}
			out.close();
		}catch(Exception e){
			e.printStackTrace();
		}
	}
	

	

	
	private List<Double> getStats(List<Pair<Protein,List<Protein>>> pList){
		List<Double> stats = new ArrayList<Double>();
		stats.add(0.0);
		double divider = 0.0;
		for (int l = 0; l <= (roundFactor*largestEntryInMatrix); l++){
			divider = 0.0;
			double counter = 0.0;
			for (int i = 0; i < pList.size(); i++){
				for(int j = i+1; j < pList.size(); j++){
					if(Math.round(Dist[i][j]*roundFactor) == l){
						counter++;
					}
					divider++;
				}
			}
			stats.add(l,(counter/divider));
		}
		System.out.println(stats);
		return stats;
	}
	

	
	private void getMatrix(List<Pair<Protein,List<Protein>>> pList, String distanceMatrixFile){
		Dist = new double[pList.size()][pList.size()];
		try{
			String s = null;
			File MFile = null;
			//if ( distanceMatrixType == 0){
				
			MFile = new File(PATH + distanceMatrixFile);
				//MFile = new File("HuPIRelationsSimMatrixp" + stopProb + "k_14Nov2010.txt");
				//MFile = new File("src/go/HuPIOriginalDistMatrix.txt");
					
				//s = "YMR323W";
				s = "<http://dbpedia.org/resource/Bharat_Sevashram_Sangha>";
			//}
				
//			else if(distanceMatrixType == 1){
//				if (stopProb == 0.1 || stopProb == 0.2){
//					MFile = new File("src/go/KroganTable7SimMatrixp"+ stopProb +"0k150.txt");
//				}
//				else{
//					MFile = new File("src/go/KroganTable7SimMatrixp"+ stopProb +"k150.txt");
//				}
	//			s = "??????";
//			}
//			else if(distanceMatrixType == 2){
				//MFile = new File("src/go/ConnectedCollinsSimP0.15k150.txt");
//				MFile = new File("src/go/CollinsConnectedSimMatrixp0.15k150.txt");
//				s = "YFR052W";
				
//			}
//			else{
//				return;
//			}
			FileReader fRM = new FileReader(MFile);
			BufferedReader MReader = new BufferedReader(fRM);
			String MLine = MReader.readLine();
			int i = 0;
			while (MLine != null){
				String[] t = MLine.split("\t");
				if (t[0].equals(s)){
					break;
				}
				for (int j = 0; j < pList.size(); j++){
					Dist[i][j] = Double.parseDouble(t[j]);
					if (Dist[i][j] > largestEntryInMatrix){
						largestEntryInMatrix = Dist[i][j];
					}
					if (Math.round(Dist[i][j]*roundFactor) > MAX){
						MAX = Math.round(Dist[i][j]*roundFactor)+1;
					}
				}
				i++;
				MLine = MReader.readLine();
			}
		}catch(Exception e){
			e.printStackTrace();
		}
	}
	
	
	private static List<Protein> createBaitList(List<Relation> relations){
		List<Protein> baits = new ArrayList<Protein>();
		for(Relation relation: relations){
			boolean found = false;
			for(Protein p: baits){
				if(relation.getBait().getName().equalsIgnoreCase(p.getName())){
					found = true;
				}
			}
			if(found == false){
				baits.add(relation.getBait());
			}
		}
		return baits;
	}
	
	
	private static List<Relation> createRelationList(BufferedReader relationsReader){
		List<Relation> relations = new ArrayList<Relation>();
		try{
			String relationLine = relationsReader.readLine();
			while (relationLine != null){
				String[] relationTokens = relationLine.split(" ");
				//Set<String> color = color(colorMap,relationTokens[0]);
				Set<String> blank = new HashSet<String>();
				Protein bait = new Protein(true,relationTokens[0],blank);
				//color = color(colorMap,relationTokens[1]);
				Protein target = new Protein(false,relationTokens[1],blank);
				//Double mascot = Double.parseDouble(relationTokens[2]);
				//Double iR = Double.parseDouble(relationTokens[4]);
				Relation relation = new Relation(bait,target,0.0,0.0);
				relations.add(relation);
				relationLine = relationsReader.readLine();
			}
			
		}
		catch(Exception e){
			e.printStackTrace();
		}
		return relations;
		
	}
	private static boolean isBait(String pName, List<Protein> baits){
		boolean isBait = false;
		for(Protein bait: baits){
			if(bait.getName().equalsIgnoreCase(pName)){
				isBait = true;
				break;
			}
		}
		return isBait;
	}
	private static List<Pair<Protein,List<Protein>>> createAdjacencyList(List<Relation> relations, List<Protein> baits){
		List<Pair<Protein,List<Protein>>> proteinList = new ArrayList<Pair<Protein,List<Protein>>>();
		for (Relation r: relations){
			String baitName = r.getBait().getName();
			String targetName = r.getTarget().getName();
			boolean foundBait = false;
			boolean foundTarget = false;
			for(Pair<Protein,List<Protein>> proteinNode: proteinList){
				if (proteinNode.getf().getName().equals(baitName)){
					boolean found = false;
					for (Protein p: proteinNode.gets()){
						if(p.getName().equalsIgnoreCase(targetName)){
							found = true;
						}
					}
					if (found == false){
						boolean isBait = isBait(targetName, baits);
						proteinNode.gets().add(new Protein(isBait,targetName,r.getTarget().getColor()));
					}
					foundBait = true;
				}
			}
			if (foundBait == false){
				boolean isBait = isBait(baitName, baits);
				Protein bait = new Protein(isBait,baitName,r.getBait().getColor());
				isBait = isBait(targetName, baits);
				Protein target = new Protein(isBait,targetName,r.getTarget().getColor());
				List<Protein> links = new ArrayList<Protein>();
				links.add(target);
				proteinList.add(new Pair<Protein,List<Protein>>(bait, links));
			}
			for(Pair<Protein,List<Protein>> proteinNode: proteinList){
				if (proteinNode.getf().getName().equals(targetName)){
					boolean found = false;
					for (Protein p: proteinNode.gets()){
						if(p.getName().equalsIgnoreCase(baitName)){
							found = true;
						}
					}
					if (found == false){
						boolean isBait = isBait(baitName, baits);
						proteinNode.gets().add(new Protein(isBait,baitName,r.getBait().getColor()));
					}
					foundTarget = true;
				}
			}
			if(foundTarget == false){
				boolean isBait = isBait(baitName, baits);
				Protein bait = new Protein(isBait,baitName,r.getBait().getColor());
				isBait = isBait(targetName, baits);
				Protein target = new Protein(isBait,targetName,r.getTarget().getColor());
				List<Protein> links = new ArrayList<Protein>();
				links.add(bait);
				proteinList.add(new Pair<Protein,List<Protein>>(target, links));
			}
		}

		return proteinList;
	}
	
	private List<Pair<Protein,List<Protein>>> readAdjacencyList(BufferedReader r){
		List<Pair<Protein,List<Protein>>> list = new ArrayList<Pair<Protein,List<Protein>>>();
		try{
			String s = r.readLine();
			while(s != null){
				String[] split = s.split(",");
				Protein p = new Protein(false,split[0],null);
				List<Protein> l = new ArrayList<Protein>();
				for(int i = 1; i < split.length; i++){
					Protein p2 = new Protein(false,split[i],null);
					l.add(p2);
				}
				Pair<Protein,List<Protein>> pair = new Pair(p,l);
				list.add(pair);
				s = r.readLine();
			}
		}catch(Exception e){
			e.printStackTrace();
		}
		return list;
	}
	
	private Set<ANGeneSet> loadGeneSets(List<Pair<Protein,List<Protein>>> pList, BufferedReader in){
		Set<ANGeneSet> geneSets = new HashSet<ANGeneSet>();
		
		
		try{
			String s = in.readLine();
			int counter = 0;
			while(s != null){
				counter++;
				System.out.println(counter);
				String[] split = s.split("\t");
				if(split.length > 1){
//					String[] split = s.split(":")[1].split("\t");
					String geneSetName = split[0];
					List<String> GenesInGeneSet = new ArrayList<String>();
					List<Pair<Protein,List<Protein>>> subList = new ArrayList<Pair<Protein,List<Protein>>>();
					for(int i = 1; i < split.length; i++){
						GenesInGeneSet.add(split[i]);
					}
					for(Pair<Protein,List<Protein>> p: pList){
						String pName = p.getf().getName();
						for(String geneNames: GenesInGeneSet){
							String[] split2 = geneNames.split(",");
							for(int j = 0; j < split2.length; j++){
								if(split2[j].equals(pName)){
									subList.add(p);
									break;
								}
							}
						}
					}
					ANGeneSet aGS = new ANGeneSet(subList, geneSetName);
					if(aGS.getProteins().size() > 1){
						geneSets.add(aGS);
					}
				}
				s = in.readLine();
			}
		}catch (Exception e) {
			e.printStackTrace();
		}
		
		return geneSets;
	}
	

	
	private boolean sameNode(TreeNode n1, TreeNode n2){
		boolean same = false;
		for(Pair<Protein,List<Protein>> p1: n1.getProteins()){
			for(Pair<Protein,List<Protein>> p2: n2.getProteins()){
				if(p1.getf().getName().equals(p2.getf().getName())){
					same = true;
					break;
				}
			}
		}
		return same;
	}
	
	private void divideCluster(TreeNode root){
		if (root.getPvalue() > root.getChild1().getPvalue() || root.getPvalue() > root.getChild2().getPvalue() ){
			if (root.getChild1().getPvalue() < significantpValue){
				divideCluster(root.getChild1());
			}
			if (root.getChild2().getPvalue() < significantpValue){
				divideCluster(root.getChild2());
			}
		}
		else{
			significantGroups.add(root);
		}
	}
	
	private Set<List<ANGeneSet>> findSignificantGeneSets(List<Pair<Protein,List<Protein>>> pList, Set<ANGeneSet> MSigGeneSets,String simuProbFile, int maxGroupSize){
		int numberOfSignificantGeneSets = 0;
		int numberOfGeneSets = 0;
		Set<List<ANGeneSet>> goodGeneSets = new HashSet<List<ANGeneSet>>();
		System.out.println("Computing Gene Set significance...");
		List<List<Double>> allSimuPValues = loadSimPValues(simuProbFile);
		for(ANGeneSet gs: MSigGeneSets){
			List<ANGeneSet> subGeneSets = new ArrayList<ANGeneSet>();
			if(gs.getProteins().size() > 2 && gs.getProteins().size() <= maxGroupSize){
				numberOfGeneSets++;
				double globalPairwiseDistance = computeSumDistance(gs.getProteins(), pList);
				double globalSimupValue = computeSimuPValue(gs.getProteins().size(), globalPairwiseDistance, allSimuPValues);
				//if(globalSimpValue < significantpValue){
				if(true){
					numberOfSignificantGeneSets++;
					double globalUpperpValue = -1.0;
					double globalLowerpValue = -1.0;
					double globalTriRoundpValue = -1.0;
					//globalUpperpValue = computeUpperPValue(gs.getProteins().size(),globalPairwiseDistance,dataSet);
					//if(!dataSet.equalsIgnoreCase("Collins") && !dataSet.equalsIgnoreCase("hupi") ){	
					//	globalLowerpValue = -1.0;
					//	if (gs.getProteins().size() < 51){
					//		globalLowerpValue = computeLowerPValue(gs.getProteins().size(),globalPairwiseDistance,dataSet);
					//	}
					//	globalTriRoundpValue = -1.0; 
					//	if (gs.getProteins().size() < 13){
					//		globalTriRoundpValue = computeTriRoundPValue(gs.getProteins().size(), globalPairwiseDistance,dataSet); 
					//	}
					//}
					double globalAvgD = (double)globalPairwiseDistance/(double)gs.getProteins().size();
					gs.setAvgD(globalAvgD);
					gs.setSimuPvalue(globalSimupValue);
					gs.setUpperPvalue(globalUpperpValue);
					gs.setLowerPValue(globalLowerpValue);
					gs.setTriRound(globalTriRoundpValue);
					gs.setTriInterpol(-1.0);
					System.out.println(gs.getProteins().size());
					System.out.println(gs.getSimuPValue());
					System.out.println(gs.getUpperPValue());
					subGeneSets.add(gs);
					
					TreeNode root = buildTree(gs,pList, allSimuPValues);
					significantGroups.clear();
					divideCluster(root);
					for (TreeNode n: significantGroups){
						List<Pair<Protein,List<Protein>>> subSetProteins = new ArrayList<Pair<Protein,List<Protein>>>();
						for (Pair<Protein,List<Protein>> p: n.getProteins()){
							subSetProteins.add(p);
						}
						ANGeneSet subGeneSet = new ANGeneSet(subSetProteins,gs.getGeneSetName());
						double sumDistance = n.getPairwiseDistance();
						double simupValue = -1.0;
						double upperpValue = n.getPvalue();
						simupValue = computeSimuPValue(n.getProteins().size(), sumDistance, allSimuPValues);
						//upperpValue = computeUpperPValue(n.getProteins().size(), sumDistance, dataSet);

						double lowerpValue = -1.0;
						//if(!dataSet.equalsIgnoreCase("Collins") && !dataSet.equalsIgnoreCase("hupi")){
						//	if(n.getProteins().size() < 51){
						//		lowerpValue = computeLowerPValue(n.getProteins().size(),sumDistance,dataSet);
						//	}
						//}
						double triRound = -1.0;
						//if(!dataSet.equalsIgnoreCase("Collins") && !dataSet.equalsIgnoreCase("hupi") ){
						//	if(n.getProteins().size() < 13){
						//		triRound = computeTriRoundPValue(n.getProteins().size(),sumDistance,dataSet);
						//	}
						//}
	//					double triInterpol = computeTriInterpolPValue(n.getProteins().size(),sumDistance,dataSet);
						double avgD = (double)sumDistance/(double)n.getProteins().size();
						if (upperpValue <= significantpValue){
							subGeneSet.setAvgD(avgD);
							subGeneSet.setSimuPvalue(simupValue);
							subGeneSet.setUpperPvalue(upperpValue);
							subGeneSet.setLowerPValue(lowerpValue);
							subGeneSet.setTriRound(triRound);
							subGeneSet.setTriInterpol(-1.0);
							subGeneSets.add(subGeneSet);
						}
					}
					if(subGeneSets.size() > 1){
						goodGeneSets.add(subGeneSets);
					}
				}
			}
		}
		System.out.println("Number of Gene Sets : " + numberOfGeneSets);
		System.out.println("Number of significant Gene sets : "+numberOfSignificantGeneSets);
		return goodGeneSets;
	}


	
	private TreeNode buildTree(ANGeneSet gs,List<Pair<Protein,List<Protein>>> pList, List<List<Double>> allSimuPValues ){
		//TreeNode(TreeNode pParent, TreeNode pChild1, TreeNode pChild2, Set<Pair<Protein,List<Protein>>> pProteins,double pPvalue){
		TreeNode root = null;
		Set<TreeNode> clusters = new HashSet<TreeNode>();
		for(Pair<Protein,List<Protein>> protein: gs.getProteins()){
			List<Pair<Protein,List<Protein>>> nodes = new ArrayList<Pair<Protein,List<Protein>>>();
			nodes.add(protein);
			List<Integer> index = new ArrayList<Integer>();
			for (Pair<Protein,List<Protein>> p: pList){
				if(p.getf().getName().equalsIgnoreCase(protein.getf().getName())){
					index.add(pList.indexOf(p));
					break;
				}
			}
			TreeNode n = new TreeNode(null,null,null,nodes,1.0,index,0);
			clusters.add(n);
		}
		
				
		int proteinNumber = clusters.size();
		
		boolean rootCreated = false;
		while(!rootCreated){
			double minDist = Double.MAX_VALUE;
			TreeNode minNode1 = null;
			TreeNode minNode2 = null;
			System.out.println(gs.getGeneSetName());
			System.out.println("Clusters "+clusters);
			for(TreeNode n1: clusters){
				System.out.println("Set ");
				for(Pair<Protein,List<Protein>> p: n1.getProteins()){
					System.out.println(p.first.getName());
				}
			}
			for(TreeNode n1: clusters){
				if (!n1.isInTree()){
					for(TreeNode n2: clusters){
						if (!n2.isInTree()){
							if (!sameNode(n1,n2)){
								double dist = getAverageDistance(n1, n2);
								System.out.println("Dist "+ dist);
								if (dist < minDist){
									minDist = dist;
									minNode1 = n1;
									System.out.println("minNode1 In Loop "+minNode1);
									minNode2 = n2;
									System.out.println("minNode2 In Loop "+minNode2);
								}
							}
						}
					}
				}
			}
			System.out.println("minNode1 "+minNode1);
			System.out.println("minNode2 "+minNode2);
			List<Pair<Protein,List<Protein>>> mergedList = new ArrayList<Pair<Protein,List<Protein>>>();
			mergedList.addAll(minNode1.getProteins());
			mergedList.addAll(minNode2.getProteins());
			List<Integer> indexes = new ArrayList<Integer>();
			indexes.addAll(minNode1.getIndexes());
			indexes.addAll(minNode2.getIndexes());
			List<Pair<Protein,List<Protein>>> mergedSet = new ArrayList<Pair<Protein,List<Protein>>>();
			for(Pair<Protein,List<Protein>> pair: mergedList){
				mergedSet.add(pair);
			}
			double pairwiseDistance = computeSumDistance(mergedSet,pList);
			//double pValue = computeUpperPValue(mergedSet.size(), pairwiseDistance, dataSet);
			double pValue = computeSimuPValue(mergedSet.size(),pairwiseDistance,allSimuPValues);
			
			TreeNode merged = new TreeNode(null,minNode1,minNode2,mergedList,pValue,indexes,pairwiseDistance);
			clusters.add(merged);
			
			minNode1.InTree();
			minNode2.InTree();
			if (mergedSet.size() == proteinNumber){
				rootCreated = true;
			}
			root = merged;
		}
		return root;
	}

	private List<List<Double>> loadSimPValues(String simuProbFile){
		List<List<Double>> allPValues = new ArrayList<List<Double>>();
		allPValues.add(new ArrayList<Double>()); //index 0
		allPValues.add(new ArrayList<Double>()); //index 1
		BufferedReader in = null; 
		
		try{
			
			in = new BufferedReader(new FileReader(new File(PATH + simuProbFile)));
			
			String line = in.readLine();
			while(line != null){
				List<Double> pValues = new ArrayList<Double>();
				String[] l = line.split(",");
				double pValue = 0.0;
				for(int i = 0; i < l.length; i++){
					pValues.add(pValue + Double.parseDouble(l[i]));
					pValue = pValues.get(i);
				}
				allPValues.add(pValues);
				line = in.readLine();
			}
			in.close();
		}catch (Exception e) {
			e.printStackTrace();
		}
		return allPValues;
	}

	
	private double computeSimuPValue(int numProteins,double dist, List<List<Double>> allPValues){
		if(dist > allPValues.get(numProteins).size()){
			return 1.0;
		}
		else{
			return allPValues.get(numProteins).get((int)dist);
		}
	}
	
	
	/*private double computeSimuPValue(int numProteins,double dist,String simuProbFile){
		double pValue = 0.0;
		try{
			BufferedReader in = null; 
			
			in = new BufferedReader(new FileReader(new File(PATH+simuProbFile)));
			
			String line = in.readLine();
			for(int i = 2; i < numProteins; i++){
				line = in.readLine();
			}
			String[] l = line.split(",");
			//for(int i = (l.length-1); i >= Math.round(sim*roundFactor); i--){
			//for(int i = (int)Math.round(sim*roundFactor); i <= (l.length-1); i++){
			for(int i = 0; i <= dist; i++){
				pValue = pValue + Double.parseDouble(l[i]);
			}
		}catch (Exception e) {
			e.printStackTrace();
		}
		return pValue;
	}*/

	private double computeSumDistance(List<Pair<Protein,List<Protein>>> pWithGo, List<Pair<Protein,List<Protein>>> pList){
		double sumDistance = 0.0;
		for (int i = 0; i < pWithGo.size(); i++){
			Pair<Protein,List<Protein>> p = pWithGo.get(i);
			for (int j = i+1; j < pWithGo.size(); j++){
				Pair<Protein,List<Protein>> p2 = pWithGo.get(j);
				
				sumDistance = sumDistance + getDistance(p.getf(),p2.getf(),pList);
			}
		}
		return sumDistance;
	}
	
	
/*	private double computeSumDistance(Set<Pair<Protein,List<Protein>>> pWithGo, List<Pair<Protein,List<Protein>>> pList){
		double sumDistance = 0.0;
		for (Pair<Protein,List<Protein>> p: pWithGo){
			for (Pair<Protein,List<Protein>> p2: pWithGo){
				if (p.getf().getName().equalsIgnoreCase(p2.getf().getName())){
					continue;
				}
				sumDistance = sumDistance + getDistance(p.getf(),p2.getf(),pList);
			}
		}
		return (sumDistance/2);
	}*/
	
	private double getDistance(Protein p1, Protein p2, List<Pair<Protein,List<Protein>>> pList){
		int i = indices.get(p1.getName());
		int j = indices.get(p2.getName());
		return Dist[i][j];
	}
	
	private double getAverageDistance(TreeNode n1, TreeNode n2){
		double distance = 0.0;
		double pairNumber = 0;
		for(int index1: n1.getIndexes()){
			for(int index2: n2.getIndexes()){
				pairNumber++;
				distance += Dist[index1][index2];
			}
		}
		distance = distance/pairNumber;
		return distance;
	}
	
	
	
	
}
